/*global Ext, kyoto, vardb */
kyoto.vardb.widgets.Comments = Ext.extend(Ext.Panel,
{	
	width: '600',
	autoScroll: true,
	pagesize: 5,
	iconCls: 'icon-user_comment',
	
	initComponent:function()
	{
		var self=this;
		//if (!this.type)
		//	{throw 'kyoto.vardb.widgets.Comments: type not set';}
		if (!this.identifier)
			{throw 'kyoto.vardb.widgets.Comments: identifier not set';}
			
		var reader = new Ext.data.JsonReader(
		{
			root: 'comments',
			totalProperty: 'totalCount',
			idProperty: 'id',
			fields:
			[
				{name: 'id', type: 'int'},
				{name: 'username'},
				{name: 'type'},
				{name: 'identifier'},
				{name: 'text'},
				{name: 'date'}
			]
		});

		var store=new Ext.data.Store(
		{
			url: vardb.webapp+'/ajax/comments',
			reader: reader,
			remoteSort: true,
			sortInfo: {field: 'date', direction: 'DESC'},
			baseParams: {identifier: this.identifier}
		});
		
		// Custom rendering Template for the View
		var resultTpl = new Ext.XTemplate('' +
				'<tpl for=".">' +
				'<div class="comment-item">' +
				'<tpl if="username!=\'system\'">' +
				'<h3><span>{date:date("M j, Y, g:i A")}<br /></span><a href="javascript:void(0)">{username} wrote:</a></h3>' +
				'</tpl>' +
				'<p>{text}</p>' +
				'</div>' +
				'</tpl>');

		var addButton=new Ext.Button(
		{
			id: 'vardb-comments-submit-btn',
			text: 'Submit a comment',
			scope: this,
			handler: this.submitHandler
		});
		
		var config=
		{
			items: new Ext.DataView({
				tpl: resultTpl,
				store: store,
				itemSelector: 'div.comment-item',
				//emptyText: '<div class="emptyText">No comments have been submitted for this item.</div>'
				emptyText: '<div class="comment-item"><p style="margin-top:5px;margin-bottom:5px;">No comments have been submitted for this item.</p></div>'
			}),
			tbar: new Ext.Toolbar(
			{
				items:
				[
					'<span class="comments-heading">User comments</span>',
					'->','-',
					addButton
				]
			}),
			bbar: new Ext.PagingToolbar(
			{				
				pageSize: this.pagesize,
				store: store,
				displayInfo: true,
				displayMsg: '{0} - {1} of {2}',
				emptyMsg: ''//No comments
			})
		};
		Ext.apply(this, Ext.apply(this.initialConfig, config));
		kyoto.vardb.widgets.Comments.superclass.initComponent.apply(this, arguments);
		
		store.load({params: {start: 0, limit: this.pagesize}});
		this.store=store;
	},
	
	submitHandler:function()
	{
		var self=this;
		var win=new kyoto.vardb.widgets.CommentWindow(
		{
			identifier: self.identifier,
			callback: function()
			{
				self.store.reload();
			}
		});
	}
});	
